// $Id$
/**
 * Script helpers for paint
 */ 

Drupal.behaviors.paint = function (context) {
  if(Drupal.jsEnabled) {
    // if javascript performance option && clean urls are enabled, this line is needed
    PaintWeb.baseFolder = Drupal.settings.paint.paintwebpath;
    // Paintweb main object
    var pw = new PaintWeb();
    var target = document.getElementById('PaintWebTarget');
    var img    = document.getElementById('editableImage');
    img.style.display = 'none';  
    pw.config.guiPlaceholder = target;
    pw.config.imageLoad      = img;
    pw.config.configFile = Drupal.settings.paint.config;
    pw.config.lang = Drupal.settings.paint.language; // Language integration
    pw.init( function (ev) {
      if (ev.state === PaintWeb.INIT_DONE) {
        $('.paintstatus').text(Drupal.t('PaintWeb successfully loaded!'));
      } else if (ev.state === PaintWeb.INIT_ERROR) {
        $('.paintstatus').text(Drupal.t('PaintWeb loading failed!'));
      }
      $('#editableImage').removeClass('loading');
      setTimeout("$('.paintstatus').css('visibility', 'hidden');",4000);
    });
    //Save Image integration
    var evId = pw.events.add('imageSave', saveHandler);
  }
};

// The imageSave event handler.
function saveHandler (ev) {
  // Cancel the default action of the event.
  ev.preventDefault();
  //get variables from the form
  var title = $('input#edit-title').val();
  $('.paintstatus').text(Drupal.t('Saving...'));
  $('.paintstatus').css('visibility', 'visible');
  var nid = "nid=0&";
  if (Drupal.settings.paint.nid != null) {
    nid = "nid=" + Drupal.settings.paint.nid + "&";
  }
  $.ajax({
    type: "POST",
    url: "?q=/paint/save",
    data: nid + "title=" + title + "&dataURL=" + encodeURIComponent(ev.dataURL) + "&form_token=" + Drupal.settings.paint.token,
    complete: function (xhr, textStatus) {
      //check if its in the correct state
      if (!xhr || xhr.readyState !== 4) {
        return;
      }
      if ((xhr.status !== 304 && xhr.status !== 200) ||
      !xhr.responseText || xhr.responseText !== 'OK') {
        // Image save failed.
        $('.paintstatus').text(Drupal.t('Image saving failed'));
      }
      else {
        // Image save was successful.
        $('.paintstatus').text(Drupal.t('Image successfully saved'));
      }
      setTimeout("$('.paintstatus').css('visibility', 'hidden');",4000);
    }
  });
};